﻿using System;
using Com.Asreader.Ascameraxsdk;

namespace AsCameraXMAUIDemo;
public class CameraCropView : GraphicsView
{
    public static readonly BindableProperty ResultListProperty = BindableProperty.Create(
      nameof(ResultList),
      typeof(IList<AsCameraXResult>),
      typeof(CameraCropView),
      null,
      propertyChanged: (bindable, value, newValue) =>
      {
          if (bindable is CameraCropView cropView)
          {
              cropView.UpdatedResult((IList<AsCameraXResult>)newValue);
          }
      });

    public IList<AsCameraXResult> ResultList
    {
        get => (IList<AsCameraXResult>)GetValue(ResultListProperty);
        set => SetValue(ResultListProperty, value);
    }


    public CameraCropView()
	{
		Drawable = new CameraCropViewDrawable();
	}


	public void UpdatedResult(IList<AsCameraXResult> mlist) {
        if (Drawable is not CameraCropViewDrawable drawable)
        {
            return;
        }

        drawable.Setlist(mlist);

        Invalidate();
    }
}


