﻿using System;
using Com.Asreader.Ascameraxsdk;
using static System.Net.Mime.MediaTypeNames;

namespace AsCameraXMAUIDemo;
public class CameraCropViewDrawable : IDrawable
{
    public Color StrokeColor { get; set; }
    public int FontSize { get; set; }
    public Color FontColor { get; set; }
    public string Text { get; set; }
    public IList<Android.Graphics.Point> Points { get; private set; }

    private IList<AsCameraXResult> list1;

    public IList<AsCameraXResult> Getlist()
    {
        return list1;
    }

    public void Setlist(IList<AsCameraXResult> value)
    {
        list1 = value;
    }

    public CameraCropViewDrawable()
    {
    }

    public void Draw(ICanvas canvas, RectF dirtyRect)
    {
        DrawResult(canvas, dirtyRect);
    }

    public void DrawResult(ICanvas canvas, RectF dirtyRect)
    {

        //canvas.SaveState();
        canvas.StrokeColor = Colors.Blue;
        canvas.StrokeSize = 6;
        IList<AsCameraXResult>  MList = Getlist();
        if (MList != null) {
            foreach (AsCameraXResult result1 in Getlist())
            {
                Points = result1.BarcodeRegions;
                if (Points != null && Points.Count != 4)
                {
                    continue;
                }
                Android.Graphics.Point topPoint = Points[0];
                Android.Graphics.Point topRightPoint = Points[1];
                Android.Graphics.Point bottomRightPoint = Points[2];
                Android.Graphics.Point bottomLeftPoint = Points[3];
                canvas.DrawLine(topPoint.X/1.5f, topPoint.Y/1.5f, topRightPoint.X/1.5f, topRightPoint.Y/1.5f);
                canvas.DrawLine(topRightPoint.X/ 1.5f, topRightPoint.Y/ 1.5f, bottomRightPoint.X/ 1.5f, bottomRightPoint.Y/ 1.5f);
                canvas.DrawLine(bottomRightPoint.X/ 1.5f, bottomRightPoint.Y/ 1.5f, bottomLeftPoint.X/ 1.5f, bottomLeftPoint.Y/ 1.5f);
                canvas.DrawLine(bottomLeftPoint.X/ 1.5f, bottomLeftPoint.Y/ 1.5f, topPoint.X/ 1.5f, topPoint.Y/ 1.5f);
            }
        }
        //canvas.RestoreState();
    }
    public void DrawText(ICanvas canvas, RectF dirtyRect)
    {
        canvas.SaveState();

        canvas.FontColor = FontColor;
        canvas.FontSize = FontSize;
        canvas.DrawString(Text, dirtyRect.X, dirtyRect.Y, dirtyRect.Width, dirtyRect.Height,
            HorizontalAlignment.Center,
            VerticalAlignment.Center);

        canvas.RestoreState();
    }

}


