﻿using Com.Asreader.Aslicensesdk;

namespace AsCameraXMAUIDemo;

public partial class MainPage : ContentPage
{
    private AsCameraXManager formManager;
    private AsCameraXCallback asCameraXCallback;
    public MainPage()
    {
        InitializeComponent();
        formManager = AsCameraXManager.sharedInstance();
        asCameraXCallback = AsCameraXCallback.sharedInstance();
    }
    protected override void OnAppearing()
    {
        base.OnAppearing();
        asCameraXCallback.ReceivedCertifiedType = (AsLicense asreader, AsLicenseCertifiedType certifiedType) =>
        {
            ReceivedCertifiedType(asreader, certifiedType);
        };
    }
    protected override void OnDisappearing()
    {
        base.OnDisappearing();
        asCameraXCallback.ReceivedCertifiedType = null;
    }
    private async void OnScanClicked(object sender, EventArgs e)
    {
        if (formManager.GetCertifiedLicense())
        {
            await Navigation.PushAsync(new BarcodePage());
        }
    }
    private async void OnSettingClicked(object sender, EventArgs e)
    {
        if (formManager.GetCertifiedLicense())
        {
            await Navigation.PushAsync(new SettingsPage());
        }
    }
    private async void OnInformationClicked(object sender, EventArgs e)
    {
        if (formManager.GetCertifiedLicense())
        {
            await Navigation.PushAsync(new InformationPage());
        }
    }
    private void ReceivedCertifiedType(AsLicense asreader, AsLicenseCertifiedType certifiedType)
    {
        MainThread.BeginInvokeOnMainThread(() =>
        {
            string failStr = "";
            if (certifiedType == AsLicenseCertifiedType.AsLicenseCertifiedTypeContractNotExist)
            {
                failStr = "No contract found";
            } else if (certifiedType == AsLicenseCertifiedType.AsLicenseCertifiedTypeCertifiedNotExist)
            {
                failStr = "No License available under your contract";
            } else if (certifiedType == AsLicenseCertifiedType.AsLicenseCertifiedTypeContractInvalid)
            {
                failStr = "Contract is not vali";
            }
            if (failStr != "")
            {
                DisplayAlert("Authentication failed", failStr, "Confirm");
            }
        });
    }
}


