﻿using Android;
using Android.App;
using Android.Content.PM;
using Android.OS;
using Android.Runtime;
using AndroidX.Core.App;

namespace AsCameraXMAUIDemo;

[Activity(Theme = "@style/Maui.SplashTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize | ConfigChanges.Density)]
public class MainActivity : MauiAppCompatActivity
{
    internal static MainActivity Instance { get; private set; }
    static readonly int REQUEST_CONTACTS = 1000;
    static string[] PERMISSIONS_CONTACT = {
                Manifest.Permission.Camera,
                Manifest.Permission.ReadPhoneState
        };
    AsCameraXCallback asCameraXCallback;
    protected override void OnCreate(Bundle savedInstanceState)
    {
        base.OnCreate(savedInstanceState);
        Instance = this;
        asCameraXCallback = AsCameraXCallback.sharedInstance();
        CheckPermission();
    }
    protected override void OnResume()
    {
        base.OnResume();
        if (asCameraXCallback.ReceivedDidBecomeActive != null)
        {
            asCameraXCallback.ReceivedDidBecomeActive(true);
        }
    }
    protected override void OnStop()
    {
        base.OnStop();
        if (asCameraXCallback.ReceivedDidBecomeActive != null)
        {
            asCameraXCallback.ReceivedDidBecomeActive(false);
        }
    }
    public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
    {
        if (requestCode == REQUEST_CONTACTS)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
        }
    }
    private void CheckPermission()
    {
        if (Build.VERSION.SdkInt < BuildVersionCodes.M)
        {
            initAsReaderManager();
            return;
        }
        if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.Camera) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadPhoneState) != (int)Permission.Granted)
        {
            ActivityCompat.RequestPermissions(this, PERMISSIONS_CONTACT, REQUEST_CONTACTS);
        }
        else
        {
            initAsReaderManager();
        }
    }
    private void initAsReaderManager()
    {
        AsCameraXManager manager = AsCameraXManager.sharedInstance();
        manager.Init();
    }
}

